VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsNetTime"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'   ****************************************************************
'   Klasse       :  clsNetTime
'   Beschreibung :
'   Autor        :  Helge Rex
'   Email        :  helge@activevb.de
'   I-Net        :  http://www.das-koenigreich.de
'   ****************************************************************

'   ****************************************************************
'   Verwendete Tips'n'Tricks/Rubriken/Klassen/Tutorials
'   -   Tip 361: Die aktuelle Internetzeit auslesen
'   ****************************************************************

'   ****************************************************************
'   Einstellungen
Option Explicit

'   ****************************************************************
'   zu implementierende Interfaces

'   ****************************************************************
'   private Konstanten
Private Const cstrNTPServer As String = "ntp1.fau.de"
Private Const clngNTPPort As Long = 37

'   ****************************************************************
'   ffentliche Konstanten

'   ****************************************************************
'   private Auflistungen

'   ****************************************************************
'   ffentliche Auflistungen

'   ****************************************************************
'   private Datentypen
Private Type SYSTEMTIME
    intYear As Integer
    intMonth As Integer
    intDayOfWeek As Integer
    intDay As Integer
    intHour As Integer
    intMinute As Integer
    intSecond As Integer
    intMilliseconds As Integer
End Type

'   ****************************************************************
'   ffentliche Datentypen

'   ****************************************************************
'   private APIs (fr ffentliche eine Methode schreiben!)
Private Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" ( _
    ByVal dwFlags As Long, _
    ByRef lpSource As Any, _
    ByVal dwMessageId As Long, _
    ByVal dwLanguageId As Long, _
    ByVal lpBuffer As String, _
    ByVal nSize As Long, _
    ByRef Arguments As Long _
) As Long

Private Declare Function GetLastError Lib "kernel32" ( _
) As Long
        
Private Declare Function SetSystemTime Lib "kernel32" ( _
    ByRef lpSystemTime As SYSTEMTIME _
) As Long

'   ****************************************************************
'   private Variablen
Private WithEvents wskTime As CSocket
Attribute wskTime.VB_VarHelpID = -1
Private blnTimeSolved As Boolean
Private strNetTime As String
Private Data As String
Private TimeDelay As Date
Private strServer As String     '   Server, der befragt wird
Private lngPort As Long         '   Port, der benutzt wird
Private blnSetTime As Boolean   '   Soll die Zeit gesetzt werden?

'   ****************************************************************
'   ffentliche Variablen

'   ****************************************************************
'   ffentliche Events

'   ****************************************************************
'   private Eigenschaften

'   ****************************************************************
'   ffentliche Eigenschaften
Public Property Get Port() As Long
    Port = lngPort
End Property

Public Property Let Port(ByVal lngData As Long)
    lngPort = lngData
End Property

Public Property Get Server() As String
    Server = strServer
End Property

Public Property Let Server(ByVal strData As String)
    strServer = strData
End Property

Public Property Get SetTime() As Boolean
    SetTime = blnSetTime
End Property

Public Property Let SetTime(ByVal blnData As Boolean)
    blnSetTime = blnData
End Property

'   ****************************************************************
'   private Methoden
Private Sub LogError(ByVal lngNumber As Long, ByRef strDescription As String)
    '   Fehler ausgeben
    Debug.Print Format$(lngNumber, "00000000") & vbTab & strDescription
End Sub

Private Sub SyncClock(strTime As String)
    '   Speicher reservieren
    Dim dblNetTime As Double
    Dim lngTimeFrom1990 As Long
    Dim datUTC As Date
    Dim udtSystemTime As SYSTEMTIME
    Dim lngResult As String
    Dim strBuffer As String
    Dim lngBufSize As Long
    
    '   Leerzeichen entfernen
    strTime = Trim(strTime)
    
    '   Sind genau vier Bytes eingetroffen?
    If Len(strTime) <> 4 Then
        '   Nein, es mu sich um einen Fehler handeln
        Call Err.Raise(vbObjectError, "SyncClock", "Unverstndliche Antwort vom Server!")
    End If
    
    '   Ausgelesene Zeit ermitteln
    dblNetTime = Asc(Mid$(strTime, 1, 1)) * 256 ^ 3 + _
                 Asc(Mid$(strTime, 2, 1)) * 256 ^ 2 + _
                 Asc(Mid$(strTime, 3, 1)) * 256 ^ 1 + _
                 Asc(Mid$(strTime, 1, 1))
              
    '   Datum im UTC-Format ermitteln
    lngTimeFrom1990 = dblNetTime - 2840140800#
    datUTC = DateAdd("s", CDbl(lngTimeFrom1990), #1/1/1990#)
    
    '   Struktur mit Daten fllen
    With udtSystemTime
        .intDay = Day(datUTC)
        .intMonth = Month(datUTC)
        .intYear = Year(datUTC)
        .intSecond = Second(datUTC)
        .intMinute = Minute(datUTC)
        .intHour = Hour(datUTC)
    End With
    
    '   UTC setzen
    lngResult = SetSystemTime(udtSystemTime)
    
    '   Ist ein Fehler aufgetreten?
    If (lngResult = 0) Then
        '   Ja, Fehlercode auslesen
        lngResult = GetLastError
        
        '   Fehlertext ausreichend gro dimensionieren
        lngBufSize = 255
        strBuffer = Space$(lngBufSize)
        
        '   Fehlertext ermitteln
        lngBufSize = FormatMessage(0, 0, lngResult, 0, strBuffer, lngBufSize, 0)
        
        '   Konnte der Fehler formatiert werden?
        If (lngBufSize <> 0) Then
            '   Ja, Fehlertext zurechtstutzen
            strBuffer = Left$(strBuffer, lngBufSize)
            
            '   Fehler melden
            Call Err.Raise(lngResult, "SyncClock", strBuffer)
        End If
    End If
    
Ende:
    '   Das war es
    Exit Sub
    
Fehler:
    '   Fehler ausgeben
    Call LogError(Err.Number, Err.Description)
    
    '   Das war es
    Resume Ende
End Sub

'   ****************************************************************
'   ffentliche Methoden
Public Sub Done()
    '   Diese Funktion schliet die Zeitsynchronisation ab.
    
    '   Fehlerbehandlung setzen
    On Error GoTo Fehler
    
Ende:
    '   Weiter im Text
    Exit Sub
    
Fehler:
    '   Fehler ausgeben
    Call LogError(Err.Number, Err.Description)
    
    '   Das war es
    Resume Ende
End Sub

Public Function Init(Optional ByVal strTimeServer As String = "ntp1.fau.de", Optional ByVal lngTimePort As Long = 37) As Boolean
    '   Diese Funktion initiiert die Zeitsynchronisation.
    
    '   Fehlerbehandlung setzen
    On Error GoTo Fehler
    
    '   Variablen prfen
    If (LenB(Trim$(strTimeServer)) = 0) Then
        strTimeServer = cstrNTPServer
    End If
    If (lngTimePort = 0) Then
        lngTimePort = clngNTPPort
    End If
    
    '   Variablen setzen
    If (LenB(strServer) = 0) Then
        strServer = strTimeServer
    End If
    If (lngPort = 0) Then
        lngPort = lngTimePort
    End If
    blnSetTime = True
    
Ende:
    '   Rckgabe setzen
    Init = True
    
    '   Weiter im Text
    Exit Function
    
Fehler:
    '   Fehler ausgeben
    Call LogError(Err.Number, Err.Description)
    
    '   Das war es
    Resume Ende
    
End Function

Public Sub Run()
    '   Diese Funktion liest die Zeit aus und setzt die Systemzeit.
    
    '   Fehlerbehandlung setzen
    On Error GoTo Fehler:
    
    '   Speicher reservieren
    Dim datStartTime As Date
    
    '   Zuerst prfen, ob bereits eine Winsock-Instanz luft
    If (wskTime Is Nothing) Then
        '   Nein, es mu eine angelegt werden
        Set wskTime = New CSocket
    Else
        '   Ja, ist die bisherige Instanz geffnet?
        If (wskTime.State <> sckClosed) Then
            '   Ja, schlieen
            wskTime.CloseSocket
        End If
    End If
    
    '   System-Events verarbeiten
    DoEvents
    
    '   Ist eine Winsock-Instanz vorhanden?
    If (Not (wskTime Is Nothing)) Then
    '   Ja, Connection einstellen
        With wskTime
            .RemoteHost = strServer
            .RemotePort = lngPort
        End With
    
        '   Ja, Instanz ffnen
        Call wskTime.Connect
        
        '   System-Events verarbeiten
        DoEvents
        
        '   Die Zeit wurde noch nicht aufgelst.
        blnTimeSolved = False
        strNetTime = vbNullString
        
        '   Startzeit auslesen
        datStartTime = Time
        
        '   Solange warten, bis die Zeit entweder geholt wurde oder TimeOut erreicht ist
        Do
            '   System-Events verarbeiten
            DoEvents
        Loop Until (blnTimeSolved) Or (DateDiff("s", datStartTime, Time) >= 10)
        
        '   Konnte verbunden werden?
        If Not (blnTimeSolved) Then
            '   Nein, melden
            MsgBox "Der Server '" & strServer & "' hat nicht oder falsch geantwortet.", vbOKOnly + vbInformation
        End If
    End If

Ende:
    '   Existiert eine Winsock-Instanz?
    If Not (wskTime Is Nothing) Then
        '   Ja, ist diese Instanz offen?
        If (wskTime.State <> sckClosed) Then
            '   Ja, jetzt schlieen
            wskTime.CloseSocket
            
            '   SystemEvents verarbeiten
            DoEvents
        End If
    End If
    
    '   Instanz entfernen
    Set wskTime = Nothing
    
    '   Das war es
    Exit Sub
    
Fehler:
    '   Fehler ausgeben
    Call LogError(Err.Number, Err.Description)
    
    '   Das war es
    Resume Ende
    
End Sub

'   ****************************************************************
'   Klassengebundene Methoden

Private Sub wskTime_OnClose()
    '   Fehlerbehandlung setzen
    On Error Resume Next
  
    '   Winsock-Instanz schlieen
    Do Until wskTime.State = sckClosed
        wskTime.CloseSocket
        DoEvents
    Loop
    
    '   Das war es
    blnTimeSolved = True
    
    '   Uhrzeit einstellen
    If blnSetTime Then
        Call SyncClock(strNetTime)
    End If
End Sub

Private Sub wskTime_OnDataArrival(ByVal bytesTotal As Long)
    '   Daten auslesen
    wskTime.GetData strNetTime, vbString
End Sub

'   ****************************************************************
'   Implementierte Methoden

